<template>
  <div>
    <transition name="loading" mode="in-out">
      <div v-if="isIframe">
        <div
          class="d-flex flex-column align-items-center justify-content-center min-vh100 p-2"
        >
          <img
            alt="Citadel"
            src="@/assets/logo.svg"
            height="200"
            class="mb-5 logo"
          />
          <span class="text-muted w-75 text-center">
            <small
              >For security reasons, Citadel cannot be embedded in an
              iframe.</small
            >
          </span>
        </div>
      </div>
      <loading v-else-if="isLoading" :progress="loadingProgress" />
      <div v-else>
        <!-- component matched by the route will render here -->
        <NuxtLayout>
          <NuxtPage />
        </NuxtLayout>
      </div>
    </transition>
  </div>
</template>

<script lang="ts" setup>
import useSystemStore from "./store/system";
import useUserStore from "./store/user";

const systemStore = useSystemStore();
const userStore = useUserStore();

const isIframe = ref(false);
const isLoading = ref(true);
const loadingProgress = ref(0);
const loadingPollInProgress = ref(false);
const loadingInterval = ref<null | number>(null);
const updateStatusInterval = ref<null | number>(null);

onMounted(() => {
  isIframe.value = window.self !== window.top;

  watch(
    isLoading,
    (isLoading) => {
      window.clearInterval(loadingInterval.value!);
      // if loading, check loading status every two seconds
      if (isLoading) {
        loadingInterval.value = window.setInterval(getLoadingStatus, 2000);
      } else {
        // else check every 20s
        loadingInterval.value = window.setInterval(getLoadingStatus, 20000);
      }
    },
    {
      immediate: true,
    },
  );
});

onBeforeUnmount(() => {
  window.clearInterval(loadingInterval.value!);
  window.clearInterval(updateStatusInterval.value!);
});

async function getLoadingStatus() {
  // Skip if previous poll in progress or if system is updating
  if (loadingPollInProgress.value) {
    return;
  }

  loadingPollInProgress.value = true;

  // First check if manager api is up
  if (loadingProgress.value <= 50) {
    loadingProgress.value = 50;

    try {
      await systemStore.getManagerApi();
      if (!systemStore.managerApi.operational) {
        isLoading.value = true;
        loadingPollInProgress.value = false;
        return;
      }
    } catch (error) {
      console.error(error);
      isLoading.value = true;
      loadingPollInProgress.value = false;
      return;
    }
  }

  // Then trigger auth check
  if (loadingProgress.value <= 80 && userStore.jwt) {
    loadingProgress.value = 80;
    try {
      await userStore.refreshJWT();
    } catch (error) {
      navigateTo("/");
    }
  }

  loadingProgress.value = 100;
  loadingPollInProgress.value = false;

  // Add slight delay so the progress bar makes
  // it to 100% before disappearing
  setTimeout(() => (isLoading.value = false), 700);
}
</script>

<style lang="scss">
@import "@/global-styles/design-system.scss";
</style>

<style lang="scss">
// Loading transitions

.loading-enter-active,
.loading-leave-active {
  transition: opacity 0.4s ease;
}
.loading-enter-from {
  opacity: 0;
  // filter: blur(70px);
}
.loading-enter-to {
  opacity: 1;
  // filter: blur(0);
}
.loading-leave {
  opacity: 1;
  // filter: blur(0);
}
.loading-leave-to {
  opacity: 0;
  // filter: blur(70px);
}

.system-alert {
  position: absolute;
  bottom: 20px;
  left: 50%;
  transform: translateX(-50%);
}

// Page changing transitions
.change-page-enter-active,
.change-page-leave-active {
  transition:
    transform 0.4s,
    opacity 0.4s ease;
}
.change-page-enter-from {
  transform: translate3d(-40px, 0, 0);
  opacity: 0;
}
.change-page-enter-to {
  transform: translate3d(0, 0, 0);
  opacity: 1;
}
.change-page-leave {
  transform: translate3d(0, 0, 0);
  opacity: 1;
}
.change-page-leave-to {
  transform: translate3d(40px, 0, 0);
  opacity: 0;
}
</style>
